//+------------------------------------------------------------------+
//|                                                   Speedometr.mq5 |
//|                                              Copyright 2016, AM2 |
//|                                      http://www.forexsystems.biz |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, AM2"
#property link      "http://www.forexsystems.biz"
#property version   "1.00"
#property strict
#property indicator_chart_window
#property indicator_plots 0

input int              FontSize     = 12;                   //  
input string           FontName     = "Arial";              //  
input color            ClrWay       = Red;                  //   -    
input color            ClrSpeed     = Yellow;               //   -    
input color            ClrTime      = White;                //   -    
input int              SpeedSound   = 20;                   //   
input ENUM_BASE_CORNER Corner       = CORNER_RIGHT_UPPER;   //    
input bool             AlertOn      = true;                 //  

bool one=true;
double LastBid;
ulong LastTime=0,T=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping

//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   Comment("");
   ObjectDelete(0,"Label1");
   ObjectDelete(0,"Label2");
   ObjectDelete(0,"Label3");
  }
//+------------------------------------------------------------------+
//|                                                    |
//+------------------------------------------------------------------+
void PutLabel(string name,string text,int x,int y,color clr)
  {
   ObjectDelete(0,name);
//---   
   ObjectCreate(0,name,OBJ_LABEL,0,0,0);
//---   
   ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y);
//---   ,      
   ObjectSetInteger(0,name,OBJPROP_CORNER,Corner);
//---  
   ObjectSetString(0,name,OBJPROP_TEXT,text);
//---   
   ObjectSetString(0,name,OBJPROP_FONT,FontName);
//---   
   ObjectSetInteger(0,name,OBJPROP_FONTSIZE,FontSize);
//---  
   ObjectSetInteger(0,name,OBJPROP_COLOR,clr);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   double speed=0,way=0,Bid=0;
   ulong dt=0;

   T=GetMicrosecondCount();
   Bid=SymbolInfoDouble(_Symbol,SYMBOL_BID); 
    
   if(LastBid!=Bid)
     {
      dt=T-LastTime;
      way=(Bid-LastBid)/_Point;
      speed=way/dt;

      // M    
      if(Corner==CORNER_RIGHT_UPPER || Corner==CORNER_RIGHT_LOWER)
        {
         PutLabel("Label1","Way: "+(string)NormalizeDouble(way,2),150,30,ClrWay);
         PutLabel("Label2","Time: "+(string)NormalizeDouble(dt,2),150,55,ClrTime);
         PutLabel("Label3","Speed: "+(string)NormalizeDouble(speed*1000000,2),150,80,ClrSpeed);
        }
      else // M    
        {
         PutLabel("Label1","Way: "+(string)NormalizeDouble(way,2),20,30,ClrWay);
         PutLabel("Label2","Time: "+(string)NormalizeDouble(dt,2),20,55,ClrTime);
         PutLabel("Label3","Speed: "+(string)NormalizeDouble(speed*1000000,2),20,80,ClrSpeed);
        }
     }
     
   LastTime=T;     
   LastBid=Bid;

   if(MathAbs(speed*1000000)<SpeedSound) one=true;
//     AlertOn
   if((MathAbs(speed*1000000)>SpeedSound && one && AlertOn))
     {
      Alert("  "+(string)SpeedSound+"   !");
      SendNotification(" : "+(string)SpeedSound+"   !");
      SendMail(" "," : "+(string)SpeedSound+"   !");
      one=false;
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
